unit uMicrobit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
  TMBImage = array[0..4, 0..4] of integer;

const
  IMAGE_MAP: array[1..63] of TMBImage = (
    //IMAGE_HEART: TMBImage =
    ((0, 1, 0, 1, 0),
    (1, 1, 1, 1, 1),
    (1, 1, 1, 1, 1),
    (0, 1, 1, 1, 0),
    (0, 0, 1, 0, 0)),
    // smilies
    //IMAGE_HAPPY: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 1, 0, 1, 0),
    (0, 0, 0, 0, 0),
    (1, 0, 0, 0, 1),
    (0, 1, 1, 1, 0)),
    //IMAGE_SMILE: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (1, 0, 0, 0, 1),
    (0, 1, 1, 1, 0)),
    //IMAGE_SAD: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 1, 0, 1, 0),
    (0, 0, 0, 0, 0),
    (0, 1, 1, 1, 0),
    (1, 0, 0, 0, 1)),
    //IMAGE_CONFUSED: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 1, 0, 1, 0),
    (0, 0, 0, 0, 0),
    (0, 1, 0, 1, 0),
    (1, 0, 1, 0, 1)),
    //IMAGE_ANGRY: TMBImage = (
    ((1, 0, 0, 0, 1),
    (0, 1, 0, 1, 0),
    (0, 0, 0, 0, 0),
    (1, 1, 1, 1, 1),
    (1, 0, 1, 0, 1)),
    //IMAGE_ASLEEP: TMBImage = (
    ((0, 0, 0, 0, 0),
    (1, 1, 0, 1, 1),
    (0, 0, 0, 0, 0),
    (0, 1, 1, 1, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_SURPRISED: TMBImage = (
    ((0, 1, 0, 1, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 1, 0, 1, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_SILLY: TMBImage = (
    ((1, 0, 0, 0, 1),
    (0, 0, 0, 0, 0),
    (1, 1, 1, 1, 1),
    (0, 0, 1, 0, 1),
    (0, 0, 1, 1, 1)),
    //IMAGE_FABULOUS: TMBImage = (
    ((1, 1, 1, 1, 1),
    (1, 1, 0, 1, 1),
    (0, 0, 0, 0, 0),
    (0, 1, 0, 1, 0),
    (0, 1, 1, 1, 0)),
    //IMAGE_MEH: TMBImage = (
    ((0, 1, 0, 1, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 1, 0),
    (0, 0, 1, 0, 0),
    (0, 1, 0, 0, 0)),
    // yes/no
    //IMAGE_YES: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 1),
    (0, 0, 0, 1, 0),
    (1, 0, 1, 0, 0),
    (0, 1, 0, 0, 0)),
    //IMAGE_NO: TMBImage = (
    ((1, 0, 0, 0, 1),
    (0, 1, 0, 1, 0),
    (0, 0, 1, 0, 0),
    (0, 1, 0, 1, 0),
    (1, 0, 0, 0, 1)),
    // clock hands
    //IMAGE_CLOCK12: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_CLOCK1: TMBImage = (
    ((0, 0, 0, 1, 0),
    (0, 0, 0, 1, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_CLOCK2: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 1, 1),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_CLOCK3: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 1, 1, 1),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_CLOCK4: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 1, 1),
    (0, 0, 0, 0, 0)),
    //IMAGE_CLOCK5: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 1, 0),
    (0, 0, 0, 1, 0)),
    //IMAGE_CLOCK6: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_CLOCK7: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 1, 0, 0, 0),
    (0, 1, 0, 0, 0)),
    //IMAGE_CLOCK8: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (1, 1, 0, 0, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_CLOCK9: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (1, 1, 1, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_CLOCK10: TMBImage = (
    ((0, 0, 0, 0, 0),
    (1, 1, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_CLOCK11: TMBImage = (
    ((0, 1, 0, 0, 0),
    (0, 1, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)),
    // arrows
    //IMAGE_ARROW_N: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 1, 1, 1, 0),
    (1, 0, 1, 0, 1),
    (0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_ARROW_NE: TMBImage = (
    ((0, 0, 1, 1, 1),
    (0, 0, 0, 1, 1),
    (0, 0, 1, 0, 1),
    (0, 1, 0, 0, 0),
    (1, 0, 0, 0, 0)),
    //IMAGE_ARROW_E: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 0, 0, 1, 0),
    (1, 1, 1, 1, 1),
    (0, 0, 0, 1, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_ARROW_SE: TMBImage = (
    ((1, 0, 0, 0, 0),
    (0, 1, 0, 0, 0),
    (0, 0, 1, 0, 1),
    (0, 0, 0, 1, 1),
    (0, 0, 1, 1, 1)),
    //IMAGE_ARROW_S: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0),
    (1, 0, 1, 0, 1),
    (0, 1, 1, 1, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_ARROW_SW: TMBImage = (
    ((0, 0, 0, 0, 1),
    (0, 0, 0, 1, 0),
    (1, 0, 1, 0, 0),
    (1, 1, 0, 0, 0),
    (1, 1, 1, 0, 0)),
    //IMAGE_ARROW_W: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 1, 0, 0, 0),
    (1, 1, 1, 1, 1),
    (0, 1, 0, 0, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_ARROW_NW: TMBImage = (
    ((1, 1, 1, 0, 0),
    (1, 1, 0, 0, 0),
    (1, 0, 1, 0, 0),
    (0, 0, 0, 1, 0),
    (0, 0, 0, 0, 1)),
    // geometry
    //IMAGE_TRIANGLE: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 1, 0, 1, 0),
    (1, 1, 1, 1, 1),
    (0, 0, 0, 0, 0)),
    //IMAGE_TRIANGLE_LEFT: TMBImage = (
    ((1, 0, 0, 0, 0),
    (1, 1, 0, 0, 0),
    (1, 0, 1, 0, 0),
    (1, 0, 0, 1, 0),
    (1, 1, 1, 1, 1)),
    //IMAGE_CHESSBOARD: TMBImage = (
    ((0, 1, 0, 1, 0),
    (1, 0, 1, 0, 1),
    (0, 1, 0, 1, 0),
    (1, 0, 1, 0, 1),
    (0, 1, 0, 1, 0)),
    //IMAGE_DIAMOND: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 1, 0, 1, 0),
    (1, 0, 0, 0, 1),
    (0, 1, 0, 1, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_DIAMOND_SMALL: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 1, 0, 1, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_SQUARE: TMBImage = (
    ((1, 1, 1, 1, 1),
    (1, 0, 0, 0, 1),
    (1, 0, 0, 0, 1),
    (1, 0, 0, 0, 1),
    (1, 1, 1, 1, 1)),
    //IMAGE_SQUARE_SMALL: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 1, 1, 1, 0),
    (0, 1, 0, 1, 0),
    (0, 1, 1, 1, 0),
    (0, 0, 0, 0, 0)),
    // animals
    //IMAGE_RABBIT: TMBImage = (
    ((1, 0, 1, 0, 0),
    (1, 0, 1, 0, 0),
    (1, 1, 1, 1, 0),
    (1, 1, 0, 1, 0),
    (1, 1, 1, 1, 0)),
    //IMAGE_COW: TMBImage = (
    ((1, 0, 0, 0, 1),
    (1, 0, 0, 0, 1),
    (1, 1, 1, 1, 1),
    (0, 1, 1, 1, 0),
    (0, 0, 1, 0, 0)),
    // musical notes
    //IMAGE_MUSIC_CROTCHET: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0),
    (1, 1, 1, 0, 0),
    (1, 1, 1, 0, 0)),
    //IMAGE_MUSIC_QUAVER: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 0, 1, 1, 0),
    (0, 0, 1, 0, 1),
    (1, 1, 1, 0, 0),
    (1, 1, 1, 0, 0)),
    //IMAGE_MUSIC_QUAVERS: TMBImage = (
    ((0, 1, 1, 1, 1),
    (0, 1, 0, 0, 1),
    (0, 1, 0, 0, 1),
    (1, 1, 0, 1, 1),
    (1, 1, 0, 1, 1)),
    // other icons
    //IMAGE_PITCHFORK: TMBImage = (
    ((1, 0, 1, 0, 1),
    (1, 0, 1, 0, 1),
    (1, 1, 1, 1, 1),
    (0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_XMAS: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 1, 1, 1, 0),
    (0, 0, 1, 0, 0),
    (0, 1, 1, 1, 0),
    (1, 1, 1, 1, 1)),
    //IMAGE_PACMAN: TMBImage = (
    ((0, 1, 1, 1, 1),
    (1, 1, 0, 1, 0),
    (1, 1, 1, 0, 0),
    (1, 1, 1, 1, 0),
    (0, 1, 1, 1, 1)),
    //IMAGE_TARGET: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 1, 1, 1, 0),
    (1, 1, 0, 1, 1),
    (0, 1, 1, 1, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_SHIRT: TMBImage = (
    ((1, 1, 0, 1, 1),
    (1, 1, 1, 1, 1),
    (0, 1, 1, 1, 0),
    (0, 1, 1, 1, 0),
    (0, 1, 1, 1, 0)),
    //IMAGE_ROLLERSKATE: TMBImage = (
    ((0, 0, 0, 1, 1),
    (0, 0, 0, 1, 1),
    (1, 1, 1, 1, 1),
    (1, 1, 1, 1, 1),
    (0, 1, 0, 1, 0)),
    //IMAGE_DUCK: TMBImage = (
    ((0, 1, 1, 0, 0),
    (1, 1, 1, 0, 0),
    (0, 1, 1, 1, 1),
    (0, 1, 1, 1, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_HOUSE: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 1, 1, 1, 0),
    (1, 1, 1, 1, 1),
    (0, 1, 1, 1, 0),
    (0, 1, 0, 1, 0)),
    //IMAGE_TORTOISE: TMBImage = (
    ((0, 0, 0, 0, 0),
    (0, 1, 1, 1, 0),
    (1, 1, 1, 1, 1),
    (0, 1, 0, 1, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_BUTTERFLY: TMBImage = (
    ((1, 1, 0, 1, 1),
    (1, 1, 1, 1, 1),
    (0, 0, 1, 0, 0),
    (1, 1, 1, 1, 1),
    (1, 1, 0, 1, 1)),
    //IMAGE_STICKFIGURE: TMBImage = (
    ((0, 0, 1, 0, 0),
    (1, 1, 1, 1, 1),
    (0, 0, 1, 0, 0),
    (0, 1, 0, 1, 0),
    (1, 0, 0, 0, 1)),
    //IMAGE_GHOST: TMBImage = (
    ((1, 1, 1, 1, 1),
    (1, 0, 1, 0, 1),
    (1, 1, 1, 1, 1),
    (1, 1, 1, 1, 1),
    (1, 0, 1, 0, 1)),
    //IMAGE_SWORD: TMBImage = (
    ((0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 1, 0, 0),
    (0, 1, 1, 1, 0),
    (0, 0, 1, 0, 0)),
    //IMAGE_GIRAFFE: TMBImage = (
    ((1, 1, 0, 0, 0),
    (0, 1, 0, 0, 0),
    (0, 1, 0, 0, 0),
    (0, 1, 1, 1, 0),
    (0, 1, 0, 1, 0)),
    //IMAGE_SKULL: TMBImage = (
    ((0, 1, 1, 1, 0),
    (1, 0, 1, 0, 1),
    (1, 1, 1, 1, 1),
    (0, 1, 1, 1, 0),
    (0, 1, 1, 1, 0)),
    //IMAGE_UMBRELLA: TMBImage = (
    ((0, 1, 1, 1, 0),
    (1, 1, 1, 1, 1),
    (0, 0, 1, 0, 0),
    (1, 0, 1, 0, 0),
    (0, 1, 1, 0, 0)),
    //IMAGE_SNAKE: TMBImage = (
    ((1, 1, 0, 0, 0),
    (1, 1, 0, 1, 1),
    (0, 1, 0, 1, 0),
    (0, 1, 1, 1, 0),
    (0, 0, 0, 0, 0)),
    //IMAGE_HEART_SMALL: TMBImage =
    ((0, 0, 0, 0, 0),
    (0, 1, 0, 1, 0),
    (0, 1, 1, 1, 0),
    (0, 0, 1, 0, 0),
    (0, 0, 0, 0, 0))
);

implementation

end.
